﻿using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.Extenions;
using ProjectManagementSystem.Common.Logger;
using ProjectManagementSystem.Device.CommandCallback;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystem.Common.Dispatch
{
    public class ProcessInfoAgv : ISimpleProcess
    {
        private Dictionary<int, bool> agvDataDict = new Dictionary<int, bool>();

        public void SimpleProcess()
        {
            var agvDataList = DeviceControl.Instance.Communication.InfoAgvDictionary.Values;

            foreach (var agvData in agvDataList)
            {
                bool record = false;

                if (!agvDataDict.TryGetValue(agvData.AgvId, out var lastAgvData))
                {
                    agvDataDict.Add(agvData.AgvId, agvData.DataValid);
                    record = true;
                }
                else
                {
                    if (agvData.DataValid != lastAgvData)
                    {
                        record = true;
                    }

                    agvDataDict[agvData.AgvId] = agvData.DataValid;
                }

                if (record)
                {
                    CLog.Instance.GetAgvLog(agvData.AgvId).WriteDebug(agvData.ToSimpleString());
                }
            }
        }
    }
}
