﻿using ProjectManagementSystem.Common.Config;
using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.Extenions;
using ProjectManagementSystem.Common.Logger;
using ProjectManagementSystem.Common.Models.Crms;
using ProjectManagementSystem.Common.Service;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystem.Common.TaskBookEvent
{
    public class TaskBookBehavior_63002 : BaseTaskBookBehaviorV2
    {
        public TaskBookBehavior_63002() : base(63002, "库位取货")
        {
        }

        public override bool TaskBookOperator(TaskData taskDetailInfo, StepData stepInfo)
        {
            try
            {
                var data = Crms.SWmsApi.GetLocationStockByLocationId(stepInfo.WareHouseID);
                if (data == null)
                {
                    return false;
                }
                if (data.Location.warehouseId == "升降机")
                {
                    
                    //var agv物料名称Addr = stepInfo.WareHouseID.GetLocationMember("产品名称(AGV)");
                    //var agv产品序号Addr = stepInfo.WareHouseID.GetLocationMember("产品序号(AGV)");
                    //var agv模型状态Addr = stepInfo.WareHouseID.GetLocationMember("模型状态(AGV)");
                    //var agv加工过程Addr = stepInfo.WareHouseID.GetLocationMember("加工过程(AGV)");
                    //var agv产品编号Addr = stepInfo.WareHouseID.GetLocationMember("产品编号(AGV)");
                    //var agv加砂时间Addr = stepInfo.WareHouseID.GetLocationMember("加砂时间(AGV)");
                    //var agv震实时间Addr = stepInfo.WareHouseID.GetLocationMember("震实时间(AGV)");
                    //var agv烘干时间Addr = stepInfo.WareHouseID.GetLocationMember("烘干时间(AGV)");
                    //var agv烘干温度Addr = stepInfo.WareHouseID.GetLocationMember("烘干温度(AGV)");
                    //var agv合箱高度Addr = stepInfo.WareHouseID.GetLocationMember("合箱高度(AGV)");
                    //var agv浇口位置Addr = stepInfo.WareHouseID.GetLocationMember("浇口位置(AGV)");
                    //var agv浇注重量Addr = stepInfo.WareHouseID.GetLocationMember("浇注重量(AGV)");
                    //var agv产品图件号Addr = stepInfo.WareHouseID.GetLocationMember("产品图件号(AGV)");
                    //if (string.IsNullOrWhiteSpace(agv物料名称Addr)
                    //    || string.IsNullOrWhiteSpace(agv产品序号Addr)
                    //    || string.IsNullOrWhiteSpace(agv模型状态Addr)
                    //    || string.IsNullOrWhiteSpace(agv加工过程Addr)
                    //    || string.IsNullOrWhiteSpace(agv产品编号Addr)
                    //    || string.IsNullOrWhiteSpace(agv加砂时间Addr)
                    //    || string.IsNullOrWhiteSpace(agv震实时间Addr)
                    //    || string.IsNullOrWhiteSpace(agv烘干时间Addr)
                    //    || string.IsNullOrWhiteSpace(agv烘干温度Addr)
                    //    || string.IsNullOrWhiteSpace(agv合箱高度Addr)
                    //    || string.IsNullOrWhiteSpace(agv浇口位置Addr)
                    //    || string.IsNullOrWhiteSpace(agv浇注重量Addr)
                    //    || string.IsNullOrWhiteSpace(agv产品图件号Addr))
                    //{
                    //    return false;
                    //}
                    //RouteConfig routeConfig = ExcelConfig.Instance.GetRouteConfig(stepInfo.WareHouseID);
                    //if (!routeConfig.PlcReadWrite.Write(agv物料名称Addr, "").IsSuccess
                    //    || !routeConfig.PlcReadWrite.Write(agv产品图件号Addr, "").IsSuccess
                    //    || !routeConfig.PlcReadWrite.Write(agv产品序号Addr, (short)0).IsSuccess
                    //    || !routeConfig.PlcReadWrite.Write(agv产品编号Addr, (short)0).IsSuccess
                    //    || !routeConfig.PlcReadWrite.Write(agv加工过程Addr, (short)0).IsSuccess
                    //    || !routeConfig.PlcReadWrite.Write(agv加砂时间Addr, (short)0).IsSuccess
                    //    || !routeConfig.PlcReadWrite.Write(agv合箱高度Addr, (short)0).IsSuccess
                    //    || !routeConfig.PlcReadWrite.Write(agv模型状态Addr, (short)0).IsSuccess
                    //    || !routeConfig.PlcReadWrite.Write(agv浇口位置Addr, (short)0).IsSuccess
                    //    || !routeConfig.PlcReadWrite.Write(agv浇注重量Addr, (short)0).IsSuccess
                    //    || !routeConfig.PlcReadWrite.Write(agv烘干时间Addr, (short)0).IsSuccess
                    //    || !routeConfig.PlcReadWrite.Write(agv烘干温度Addr, (short)0).IsSuccess
                    //    || !routeConfig.PlcReadWrite.Write(agv震实时间Addr, (short)0).IsSuccess
                    //    )
                    //{
                    //    return false;
                    //}

                }
                var result = Crms.PmsTaskService.StockMoveLocationToAgv(taskDetailInfo, stepInfo, out var message);
                if (result)
                {
                    //灭叫料盒灯
                    //int route = stepInfo.WareHouseID.GetLocationMember("放行任务路线").ToValue<int>();
                    //if (route > 0)
                    //{
                    //    for (int i = 0; i < 2; i++)
                    //    {
                    //        DeviceControl.Instance.CallBoxLightOff(route);
                    //        System.Threading.Thread.Sleep(100);
                    //    }
                    //}
                }

                Log(taskDetailInfo, stepInfo, message);
                return result;
            }
            catch (Exception ex)
            {
                LogException(ex);
            }
            return false;
        }
    }
}

