﻿using DbCommon.BusinessCore.BaseCore;
using Mapster;
using ProjectManagementSystem.Common.Core;
using ProjectManagementSystem.Common.Extenions;
using ProjectManagementSystem.Common.Logger;
using ProjectManagementSystem.Common.Models;
using ProjectManagementSystem.Common.Models.Crms;
using ProjectManagementSystem.Common.Service;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectManagementSystem.Common.TaskEvent
{
    public class ProcessPmsTaskInfoClear : ICustomProcess
    {
        private PmsTaskInfoManager pmsTaskInfoManger = new PmsTaskInfoManager();
        public void CustomProcess(List<TaskData> taskDataList)
        {
            //预约任务处理
            var dataList = pmsTaskInfoManger.Query();

            for (int i = 0; i < dataList.Count; i++)
            {
                var data = dataList[i];

                PackControlCrms.Instance.StationDictionary.TryGetValue(data.LocationCode, out var packStationV2);

                if (packStationV2 != null
                    && packStationV2.AgvList?.Exists(d => d.carrier == data.Carrier) == false)
                {
                    var deleteResult = pmsTaskInfoManger.Delete(data.TaskID);
                    CLog.Instance.TaskLog.WriteInfo($"{data.LocationCode} 删除预约任务{deleteResult.ToChineseString()} {data.TaskID}");
                }
            }
        }
    }
}
